/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// CREATED BY DANY:
// FEBRUARY 2007:
/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ******************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		int subCiv4=-1;
        int subCiv5=-1;
/*----------------------------------------------------------------------------------------------------------------*/
        if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");

		subCiv1=rmGetCivID("Aztecs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Aztecs"); 

		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");

		subCiv3=rmGetCivID("Maya");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Maya");

		subCiv4=rmGetCivID("Maya");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Maya");

		subCiv5=rmGetCivID("Maya");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Maya");
   }		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
        int playerTiles=25000;
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/
        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(1.0);

        // SET THE MAP ELEVATION PARAMETERS:
	    // rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.2, 3.0);
	    
		// PICKS DEFAULT WATER:
		rmSetSeaType("new england coast");
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("patagonia_grass");
        
		// TERRAIN INITIALIZE:
		rmTerrainInitialize("patagonia\ground_dirt1_pat", 4.0);
	    
		// SET MAP TYPE:
		rmSetMapType("patagonia");
	    rmSetMapType("water");
	    rmSetMapType("grass");
        
		// SET LIGHTING:
		rmSetLightingSet("patagonia");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);

	    // CHOOSE MERCS:
	    chooseMercs();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ************************** DEFINE SOME CLASSES THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
        int classPlayer=rmDefineClass("player");
        rmDefineClass("classCliff");
        rmDefineClass("classPatch");
        int classbigContinent=rmDefineClass("big continent");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("classWestForest");
        rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("bay");
	    rmDefineClass("nuggets");
	    rmDefineClass("socketClass");
	    int lakeClass=rmDefineClass("lake");
        rmDefineClass("natives");		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
        int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, 24.0);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
        int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
        int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 30.0);
        int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);

        // BONUS AREA CONSTRAINT:
        int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 20.0);

        // RESOURCE AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
        int westForestConstraint=rmCreateClassDistanceConstraint("west forest vs. forest", rmClassID("classWestForest"), 35.0);
        
		// START RESOURCE AVOIDANCE:
		int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
        
		// COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "mine", 17.50);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("stuff close avoid coin", "mine", 5.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 5.0);
		int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("fruits avoid fruits", "berrybush", 15.0);
        
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 17.50);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("stuff close avoid nugget", "AbstractNugget", 5.0);
        int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 25.0);
        
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoid natives", rmClassID("natives"), 12.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("stuff close avoid natives", rmClassID("natives"), 5.0);

		
		// FOOD AVOIDANCE:
		int avoidBighornSheep=rmCreateTypeDistanceConstraint("bighorn avoids bighorn", "deer", 35.0);
        int avoidMoose=rmCreateTypeDistanceConstraint("moose avoids moose", "Moose", 35.0);
		int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 30.0);
		int avoidRhea=rmCreateTypeDistanceConstraint("rhea avoids rhea", "rhea", 10.0);
        
		// SEA FOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 3.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 2.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	    
		// FOREST AVOIDANCE:
		int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 60.0);
	    int avoidFastCoinForest=rmCreateTypeDistanceConstraint("forests avoid fast coin", "gold", 10.0);

        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 30.0);
        int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

	    // LAKE AVOIDANCE:
		int avoidLake=rmCreateClassDistanceConstraint("lake vs stuff", lakeClass, 30.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // STARTING UNITS AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // TRADE ROUTE AVOIDANCE:
        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	    int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 5.0);
	    int avoidSocketCliff=rmCreateClassDistanceConstraint("cliffs avoid sockets by a lot", rmClassID("socketClass"), 10.0);
	    int avoidSocketPlayer=rmCreateClassDistanceConstraint("cliffs avoid sockets by a lot more", rmClassID("socketClass"), 15.0);
        int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
        int secretsAvoidSecrets = rmCreateClassDistanceConstraint("secrets avoid secrets", rmClassID("secrets"), 60.0);
        
		
		// CONSTRAINTS TO AVOID WATER:
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 8.0);

        // CARDINAL DIRECTIONS CONSTRAINTS: (HANDY!)
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

        // SHIPS VS. SHIPS:
        int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 15.0);

        // NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

	    // CIRCLE CONSTRAINT:
	    int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
		
		// BEACH AVOIDANCE:
		// int avoidBeach = rmCreateAreaDistanceConstraint("stay away from InnerLandID", InnerLandID, 4);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE COINS: ***************************************** //
/*================================================================================================================*/
        int Coins1ID=rmCreateObjectDef("The Coins 1");
	    rmAddObjectDefItem(Coins1ID, "mine", 1, 0.0);
	    rmSetObjectDefMinDistance(Coins1ID, 0.0);
	    rmSetObjectDefMaxDistance(Coins1ID, 0.0);
	    rmAddObjectDefConstraint(Coins1ID, avoidCoin);
	    rmPlaceObjectDefAtLoc(Coins1ID, 0, 0.1, 0.4);
		rmPlaceObjectDefAtLoc(Coins1ID, 0, 0.1, 0.6);
		rmPlaceObjectDefAtLoc(Coins1ID, 0, 0.3, 0.6);
		rmPlaceObjectDefAtLoc(Coins1ID, 0, 0.3, 0.4);
		
		int Coins2ID=rmCreateObjectDef("The Coins 2");
	    rmAddObjectDefItem(Coins2ID, "mine", 1, 0.0);
	    rmSetObjectDefMinDistance(Coins2ID, 0.0);
	    rmSetObjectDefMaxDistance(Coins2ID, 0.0);
	    rmAddObjectDefConstraint(Coins2ID, avoidCoin);
	    rmPlaceObjectDefAtLoc(Coins2ID, 0, 0.7, 0.4);
		rmPlaceObjectDefAtLoc(Coins2ID, 0, 0.7, 0.6);
		rmPlaceObjectDefAtLoc(Coins2ID, 0, 0.9, 0.6);
		rmPlaceObjectDefAtLoc(Coins2ID, 0, 0.9, 0.4); 
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE TREASURES: *************************************** //
/*================================================================================================================*/
        int Nugget1ID=rmCreateObjectDef("The Treasures 1");
	    rmAddObjectDefItem(Nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(Nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(Nugget1ID, 0.0);
	    rmAddObjectDefConstraint(Nugget1ID, avoidNugget);
	    rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.05, 0.5);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.2, 0.65);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.35, 0.5);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.2, 0.35);
		
		int Nugget2ID=rmCreateObjectDef("The Treasures 2");
	    rmAddObjectDefItem(Nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(Nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(Nugget2ID, 0.0);
	    rmAddObjectDefConstraint(Nugget2ID, avoidNugget);
	    rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.65, 0.5);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.8, 0.65);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.95, 0.5);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.8, 0.35);  		
/*================================================================================================================*/
// ******************************************* CREATE TWO BAY AREAS: ******************************************** //
/*================================================================================================================*/	   
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
            // BAY 1:
		int bay1ID=rmCreateArea("Bay 1");
        rmSetAreaSize(bay1ID, 0.025, 0.025);
	    //rmSetAreaLocation(bay1ID, 1.0, 0.45);
		rmSetAreaLocation(bay1ID, 0.2, 0.5);
	    rmSetAreaWaterType(bay1ID, "hudson bay");
        rmSetAreaBaseHeight(bay1ID, 1.0); // Was 10
        rmSetAreaMinBlobs(bay1ID, 4);
        rmSetAreaMaxBlobs(bay1ID, 6);
        rmSetAreaMinBlobDistance(bay1ID, 5);
        rmSetAreaMaxBlobDistance(bay1ID, 30);
        rmSetAreaSmoothDistance(bay1ID, 50);
        rmSetAreaCoherence(bay1ID, 0.4);
	    rmAddAreaToClass(bay1ID, rmClassID("bay"));
        rmSetAreaObeyWorldCircleConstraint(bay1ID, false);
		rmAddAreaConstraint(bay1ID, avoidCoin);
		rmAddAreaConstraint(bay1ID, avoidNugget);
	    rmBuildArea(bay1ID);

        // BAY 2:
		int bay2ID=rmCreateArea("Bay 2");
        rmSetAreaSize(bay2ID, 0.025, 0.025);
	    //rmSetAreaLocation(bay2ID, 0.55, 0.0);
		rmSetAreaLocation(bay2ID, 0.8, 0.50);
	    rmSetAreaWaterType(bay2ID, "hudson bay");
        rmSetAreaBaseHeight(bay2ID, 1.0); // Was 10
        rmSetAreaMinBlobs(bay2ID, 4);
        rmSetAreaMaxBlobs(bay2ID, 6);
        rmSetAreaMinBlobDistance(bay2ID, 5);
        rmSetAreaMaxBlobDistance(bay2ID, 30);
        rmSetAreaSmoothDistance(bay2ID, 50);
        rmSetAreaCoherence(bay2ID, 0.4);
	    rmAddAreaToClass(bay2ID, rmClassID("bay"));
        rmSetAreaObeyWorldCircleConstraint(bay2ID, false);
		rmAddAreaConstraint(bay2ID, avoidCoin);
		rmAddAreaConstraint(bay2ID, avoidNugget);
        rmBuildArea(bay2ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ***************************************** DEFINE THE PLACEMENT ORDER: **************************************** //
/*================================================================================================================*/
   // Trade route -> Player Areas -> Lake -> Cliffs -> Nuggets
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	    int tradeRouteID = rmCreateTradeRoute();
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 12.0);

	    rmAddTradeRouteWaypoint(tradeRouteID, 0.2, 0.8);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.8);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.5);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.2);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.8, 0.2);
	    //rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.2, 0.3, 10, 4);

        bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.0);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.25);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.75);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 1.0);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	    rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(0);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(1,0.75,0.75);

        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(1);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(2,0.250,0.250);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ****************************************** SET UP THE PLAYER AREAS: ****************************************** //
/*================================================================================================================*/
        // FLOAT PLAYER FRACTION:
		float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
	    
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(i, avoidSocketPlayer);
		//rmAddAreaConstraint(i, avoidSocketPlayer);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		// rmAddAreaConstraint(id, playerConstraint); 
        // rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/
 // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE TRADE ROUTE HACK: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// *************************************** ADDING A LAKE IN THE MIDDLE: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ****************** DEFINING THE STARTING TCID...THE STARTING UNITS...THE STARTING RESOURCES: ***************** //
/*================================================================================================================*/
        // DEFINING THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);

	    // DEFINING THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));

	    // DEFINING THE VARIABLES OF THE STARTING SILVER:
		int silverType = -1;
	    int playerGoldID = -1;

	    // DEFINING THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreePatagoniaDirt", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINING THE STARTING DEERS:
		int StartDeerID=rmCreateObjectDef("starting deer");
	    rmAddObjectDefItem(StartDeerID, "deer", 1, 0.0);
	    rmSetObjectDefMinDistance(StartDeerID, 10.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 15.0);
	    rmAddObjectDefConstraint(StartDeerID, avoidStartingUnitsSmall);

	    // DEFINING THE STARTING BERRY BUSH:
		int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 2, 4.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	    rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);

	    // DEFINING THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    
	    // DEFINING THE VARIABLE OF THE WATER FLAG:
		int waterFlagID=-1;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *********************** PLACING THE STARTING TCID...STARTING UNITS...STARTING RESOURCES: ********************* //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
		// CLEAR CLOSEST POINTS CONSTRAINTS:
		rmClearClosestPointConstraints();
		
		// PLACING THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// EVERYONE GETS ONE ORE MINE CLOSE BY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE STARTING PRONGHORNS:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		rmAddClosestPointConstraint(Eastward);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		rmClearClosestPointConstraints();
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE NATIVES TRIBES: *************************************** //
/*================================================================================================================*/
        if (subCiv0 == rmGetCivID("aztecs"))
	{  
		int aztecs1VillageID = -1;
		aztecs1VillageID = rmCreateGrouping("aztecs village 1", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs1VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs1VillageID, 0.0);
		//rmAddGroupingConstraint(aztecs1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(aztecs1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs1VillageID, avoidNatives);
		//rmAddGroupingConstraint(aztecs1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(aztecs1VillageID, 0, 0.4, 0.7);
	} 

	    if (subCiv1 == rmGetCivID("aztecs"))
	{  
		int aztecs2VillageID = -1;
		aztecs2VillageID = rmCreateGrouping("aztecs village 2", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs2VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs2VillageID, 0.0);
		//rmAddGroupingConstraint(aztecs2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(aztecs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs2VillageID, avoidNatives);
		//rmAddGroupingConstraint(aztecs2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(aztecs2VillageID, 0, 0.6, 0.3);
	} 

/*	if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecsVillageID = -1;
		aztecsVillageID = rmCreateGrouping("aztecs village", "native aztec village 1");
		rmSetGroupingMinDistance(aztecsVillageID, 0.0);
		rmSetGroupingMaxDistance(aztecsVillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(aztecsVillageID, avoidImpassableLand);
		rmAddGroupingToClass(aztecsVillageID, rmClassID("importantItem"));
		rmAddGroupingConstraint(aztecsVillageID, avoidImportantItem);
		rmAddGroupingConstraint(aztecsVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(aztecsVillageID, 0, 0.5, 0.5);
	}

	if (subCiv3 == rmGetCivID("maya"))
	{  
		int mayaVillageID = -1;
		mayaVillageID = rmCreateGrouping("maya village", "native maya village 1");
		rmSetGroupingMinDistance(mayaVillageID, 0.0);
		rmSetGroupingMaxDistance(mayaVillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(mayaVillageID, avoidImpassableLand);
		rmAddGroupingToClass(mayaVillageID, rmClassID("importantItem"));
		rmAddGroupingConstraint(mayaVillageID, avoidImportantItem);
		rmAddGroupingConstraint(mayaVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(mayaVillageID, 0, 0.5, 0.5);
	} 
	
	if (subCiv4 == rmGetCivID("lakota"))
	{  
		int lakotaVillageID = -1;
		lakotaVillageID = rmCreateGrouping("lakota village", "native lakota village 1");
		rmSetGroupingMinDistance(lakotaVillageID, 0.0);
		rmSetGroupingMaxDistance(lakotaVillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(lakotaVillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakotaVillageID, rmClassID("importantItem"));
		rmAddGroupingConstraint(lakotaVillageID, avoidImportantItem);
		rmAddGroupingConstraint(lakotaVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.5, 0.5);
	} 

	if (subCiv5 == rmGetCivID("nootka"))
	{  
		int nootkaVillageID = -1;
		nootkaVillageID = rmCreateGrouping("nootka village", "native nootka village 1");
		rmSetGroupingMinDistance(nootkaVillageID, 0.0);
		rmSetGroupingMaxDistance(nootkaVillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(nootkaVillageID, avoidImpassableLand);
		rmAddGroupingToClass(nootkaVillageID, rmClassID("importantItem"));
		rmAddGroupingConstraint(nootkaVillageID, avoidImportantItem);
		rmAddGroupingConstraint(nootkaVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(nootkaVillageID, 0, 0.5, 0.5);
	}  */
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE CLIFFS: ***************************************** //   
/*================================================================================================================*/		  
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 6.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);
/*================================================================================================================*/
// **************************** FAST COIN -- WHALES (REASONABLE IN PATAGONIA, RIGHT?) *************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ********************************* ORE MINES, TO BE AVOIDED BY FORESTS, ETC: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BERRYBUSH: **************************************** //
/*================================================================================================================*/
        int Berries1ID=rmCreateObjectDef("The Berries 1");
	    rmAddObjectDefItem(Berries1ID, "berrybush", rmRandInt(8,10), 6.0);
	    rmSetObjectDefMinDistance(Berries1ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries1ID, 0.0);
	    rmAddObjectDefConstraint(Berries1ID, avoidFruits);
	    rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.3, 0.1);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.1, 0.3);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.9, 0.7);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.7, 0.9);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.94);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int forestTreeID = 0;
        int numTries=12*cNumberNonGaiaPlayers;
        int failCount=0;
        for (i=0; <numTries)
    {   
        int forest=rmCreateArea("forest "+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forest, "patagonia forest");
		// rmSetAreaForestType(forest, "dunes");
        rmSetAreaForestDensity(forest, 1.0);
        rmSetAreaForestClumpiness(forest, 0.2);
        rmSetAreaForestUnderbrush(forest, 0.0);
        /*
		rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 4);
        rmSetAreaMinBlobDistance(forest, 4.0);
        rmSetAreaMaxBlobDistance(forest, 12.0);
		*/
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, avoidFruits);
		rmAddAreaConstraint(forest, avoidCloseNatives);
		rmAddAreaConstraint(forest, avoidCloseCoin);
		rmAddAreaConstraint(forest, avoidCloseNugget);
		rmAddAreaConstraint(forest, avoidFastCoinForest);
        rmAddAreaConstraint(forest, avoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidTradeRoute); 
		rmAddAreaConstraint(forest, avoidStartingUnits); 
		rmAddAreaConstraint(forest, avoidSocket); 
		//rmAddAreaConstraint(forest, Eastward); 
        if(rmBuildArea(forest)==false)
        {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
        }
        else
        failCount=0; 
    } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.96);
/*================================================================================================================*/
// ********************************** HACK REPLACING BIGHORN WITH DEER FOR NOW: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int bighornID=rmCreateObjectDef("bighorn sheep herd");
	    rmAddObjectDefItem(bighornID, "bighornsheep", rmRandInt(5,7), 6.0);
        rmSetObjectDefMinDistance(bighornID, 0.0);
        rmSetObjectDefMaxDistance(bighornID, 0.0);
        rmAddObjectDefConstraint(bighornID, avoidBighornSheep);
        rmSetObjectDefCreateHerd(bighornID, true);
	    rmPlaceObjectDefAtLoc(bighornID, 0, 0.4, 0.2);
		rmPlaceObjectDefAtLoc(bighornID, 0, 0.7, 0.15);
		rmPlaceObjectDefAtLoc(bighornID, 0, 0.6, 0.8);
		rmPlaceObjectDefAtLoc(bighornID, 0, 0.3, 0.85);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.98);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE RHEA: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int rhea1ID=rmCreateObjectDef("rhea flock 1");
        rmAddObjectDefItem(rhea1ID, "rhea", rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(rhea1ID, 0.0);
        rmSetObjectDefMaxDistance(rhea1ID, 0.0);
	    rmAddObjectDefConstraint(rhea1ID, avoidRhea);
	    rmSetObjectDefCreateHerd(rhea1ID, true);
	    rmPlaceObjectDefAtLoc(rhea1ID, 0, 0.45, 0.05); 
		rmPlaceObjectDefAtLoc(rhea1ID, 0, 0.45, 0.35); 
		rmPlaceObjectDefAtLoc(rhea1ID, 0, 0.55, 0.95); 
		rmPlaceObjectDefAtLoc(rhea1ID, 0, 0.55, 0.65); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE SHEEP: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int sheep1ID=rmCreateObjectDef("The Sheep 1");
	    rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(8,10), 6.0);
	    rmSetObjectDefMinDistance(sheep1ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep1ID, 0.0);
	    rmAddObjectDefConstraint(sheep1ID, avoidSheep);
	    rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.85, 0.25);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.15, 0.75);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.6, 0.1);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.4, 0.9);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*================================================================================================================*/
     
































